# Class X509CRLEntry

java.lang.Object
java.security.cert.X509CRLEntry

All Implemented Interfaces:
  `X509Extension`

public abstract class X509CRLEntry extends Object implements X509Extension

Abstract class for a revoked certificate in a CRL (Certificate Revocation List). The ASN.1 definition for revokedCertificates is:

    revokedCertificates    SEQUENCE OF SEQUENCE  {
        userCertificate    CertificateSerialNumber,
        revocationDate     ChoiceOfTime,
        crlEntryExtensions Extensions OPTIONAL
                           -- if present, must be v2
    }  OPTIONAL

    CertificateSerialNumber  ::=  INTEGER

    Extensions  ::=  SEQUENCE SIZE (1..MAX) OF Extension

    Extension  ::=  SEQUENCE  {
        extnId        OBJECT IDENTIFIER,
        critical      BOOLEAN DEFAULT FALSE,
        extnValue     OCTET STRING
                      -- contains a DER encoding of a value
                      -- of the type registered for use with
                      -- the extnId object identifier value
    }

Since:
  1.2
See Also:
  - `X509CRL`
  - `X509Extension`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `X509CRLEntry()`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object other)`
  Compares this CRL entry for equality with the given object.
  `X500Principal`
  `getCertificateIssuer()`
  Get the issuer of the X509Certificate described by this entry.
  `abstract byte[]`
  `getEncoded()`
  Returns the ASN.1 DER-encoded form of this CRL Entry, that is the inner SEQUENCE.
  `abstract Date`
  `getRevocationDate()`
  Gets the revocation date from this X509CRLEntry, the revocationDate.
  `CRLReason`
  `getRevocationReason()`
  Returns the reason the certificate has been revoked, as specified in the Reason Code extension of this CRL entry.
  `abstract BigInteger`
  `getSerialNumber()`
  Gets the serial number from this X509CRLEntry, the userCertificate.
  `abstract boolean`
  `hasExtensions()`
  Returns true if this CRL entry has extensions.
  `int`
  `hashCode()`
  Returns the hashcode value for this CRL entry from its encoded form.
  `abstract String`
  `toString()`
  Returns a string representation of this CRL entry.

  ### Methods declared in class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface X509Extension

  `getCriticalExtensionOIDs, getExtensionValue, getNonCriticalExtensionOIDs, hasUnsupportedCriticalExtension`
  Modifier and Type
  Method
  Description
  `Set<String>`
  `getCriticalExtensionOIDs()`
  Gets a Set of the OID strings for the extension(s) marked CRITICAL in the certificate/CRL managed by the object implementing this interface.
  `byte[]`
  `getExtensionValue(String oid)`
  Gets the DER-encoded OCTET string for the extension value (extnValue) identified by the passed-in `oid` String.
  `Set<String>`
  `getNonCriticalExtensionOIDs()`
  Gets a Set of the OID strings for the extension(s) marked NON-CRITICAL in the certificate/CRL managed by the object implementing this interface.
  `boolean`
  `hasUnsupportedCriticalExtension()`
  Check if there is a critical extension that is not supported.

- ## Constructor Details

  - ### X509CRLEntry

    public X509CRLEntry()
    Constructor for subclasses to call.

- ## Method Details

  - ### equals

    public boolean equals(Object other)
    Compares this CRL entry for equality with the given object. If the `other` object is an `instanceof` `X509CRLEntry`, then its encoded form (the inner SEQUENCE) is retrieved and compared with the encoded form of this CRL entry.
    Overrides:
      `equals` in class `Object`
    Parameters:
      `other` - the object to test for equality with this CRL entry.
    Returns:
      true iff the encoded forms of the two CRL entries match, false otherwise.
    See Also:
      - `Object.hashCode()`
      - `HashMap`

  - ### hashCode

    public int hashCode()
    Returns the hashcode value for this CRL entry from its encoded form.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      the hashcode value for this CRL entry from its encoded form
    See Also:
      - `Object.equals(java.lang.Object)`
      - `System.identityHashCode(Object)`

  - ### getEncoded

    public abstract byte[] getEncoded() throws CRLException
    Returns the ASN.1 DER-encoded form of this CRL Entry, that is the inner SEQUENCE.
    Returns:
      the encoded form of this certificate
    Throws:
      `CRLException` - if an encoding error occurs.

  - ### getSerialNumber

    public abstract BigInteger getSerialNumber()
    Gets the serial number from this X509CRLEntry, the userCertificate.
    Returns:
      the serial number.

  - ### getCertificateIssuer

    public X500Principal getCertificateIssuer()
    Get the issuer of the X509Certificate described by this entry. If the certificate issuer is also the CRL issuer, this method returns null.

    This method is used with indirect CRLs. The default implementation always returns null. Subclasses that wish to support indirect CRLs should override it.

    Returns:
      the issuer of the X509Certificate described by this entry or null if it is issued by the CRL issuer.
    Since:
      1.5

  - ### getRevocationDate

    public abstract Date getRevocationDate()
    Gets the revocation date from this X509CRLEntry, the revocationDate.
    Returns:
      the revocation date.

  - ### hasExtensions

    public abstract boolean hasExtensions()
    Returns true if this CRL entry has extensions.
    Returns:
      true if this entry has extensions, false otherwise.

  - ### toString

    public abstract String toString()
    Returns a string representation of this CRL entry.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of this CRL entry.

  - ### getRevocationReason

    public CRLReason getRevocationReason()
    Returns the reason the certificate has been revoked, as specified in the Reason Code extension of this CRL entry.
    Returns:
      the reason the certificate has been revoked, or `null` if this CRL entry does not have a Reason Code extension
    Since:
      1.7